/* Example 2: Using MPI_Allreduce() */

#define MAX 5

int main(int *argc, char *argv[]){
  int i, res;
  int source, dest;
  int i_in[MAX], i_res[MAX];
  double time;
  MPI_Status status;

  MPI_Init(argc, argv);
  time = MPI_Wtime();

  // Initialize array
  for (i=0; i<MAX; i++) {
    i_in[i] = i+node_abs_id;
    i_res[i] = 0;
  }

  // Calling Allreduce()
  res = MPI_Allreduce(i_in, i_res, MAX, MPI_INT, MPI_SUM, MPI_COMM_WORLD);

  // Output results
  printf("-- Allreduce(%d) --\n", res);
  for (i=0; i<MAX; i++) {
    printf("i[%d]=%d\n", i, i_res[i]);
    mfputi(0, 0, 0, machine_size_x-1, machine_size_y-1, machine_size_z-1, i_res[i]);
  }

  // Measure execution time 
  time = MPI_Wtime() - time;
  printf("Seconds : %f.\n", time);

  MPI_Finalize();
  return 0;
}
