/* Example 3: Using MPI_Sendrecv() */

#define MAX 5

int main(int *argc, char *argv[]){
  int i, rank, size, res;
  int source, dest;
  double i_in[MAX], i_res[MAX];
  double time;
  char c[MPI_MAX_PROCESSOR_NAME];

  MPI_Init(argc, argv);
  time = MPI_Wtime();

  // Just for fun
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Get_processor_name(c, &i);
  printf("Node: %s\n", c);


  // Initialize array
  for (i=0; i<MAX; i++) {
    i_in[i] = i * time;
    i_res[i] = 0;
  }

  // Calculating source and dest
  dest = GetNextNodeX(rank); 
  source = GetPrevNodeX(rank);

  // Calling Sendrecv()
  res = MPI_Sendrecv(i_in, MAX, MPI_DOUBLE, dest, 0, i_in, MAX, MPI_DOUBLE, source, 0, MPI_COMM_WORLD, &status);


  // Output
  printf("-- Sendrecv(%d) --\n", res);
  for (i=0; i<MAX; i++) {
    printf("i[%d]=%d\n", i, i_res[i]);
    mputi(0, 0, 0, machine_size_x-1, machine_size_y-1, machine_size_z-1, i_in[i]);

    printf("r[%d]=%d\n", i, i_res[i]);
    mputi(0, 0, 0, machine_size_x-1, machine_size_y-1, machine_size_z-1, i_res[i]);

  }

  time = MPI_Wtime() - time;
  printf("Seconds : %f.\n", time);

  // Shut down MPI
  MPI_Finalize();
  return 0;
}
